package fr.wikimedia.miniServer;

import java.io.*;
import java.util.*;
import java.util.zip.*;

class ManyZipFileBuckets {
    String base;
    int modulo;
    
    ManyZipFileBuckets(String base, int modulo) {
	this.base = base;
	this.modulo = modulo;
    }

    String getCompressedName(int hash, String extension) {
	StringBuffer buffer = new StringBuffer(base);
	buffer.append(File.separatorChar);
	buffer.append(hash % 10);
	buffer.append(File.separatorChar);
	buffer.append("fil");
	String num = Integer.toString(hash);
	for(int i=num.length(); i<5; i++) buffer.append('0');
	buffer.append(num);
	buffer.append('.');
	buffer.append(extension);
	return buffer.toString();
	/*
	return new Formatter()
	    .format("%1$s%2$c%3$01d%2$cfil%4$05d.%5$s",
		    base, File.separatorChar, hash % 10, hash, extension)
	    .toString();
	*/
    }

    int hash(String filename) {
	return (filename.hashCode() & 0x7FFFFFFF) % modulo;
    }

    String getCompressedName(String filename, String extension) {
	return getCompressedName(hash(filename), extension);
    }

    final static String STORAGE_EXTENSION = "zi7", INDEX_EXTENSION = "lsz";

    String getCompressedStorageName(String filename) {
	return getCompressedName(filename, STORAGE_EXTENSION);
    }

    String getCompressedIndexName(String filename) {
	return getCompressedName(filename, INDEX_EXTENSION);
    }

    boolean isInIndex(String filename) throws IOException {
	BufferedReader reader = new BufferedReader(new InputStreamReader(new GZIPInputStream(new FileInputStream(getCompressedIndexName(filename))), "UTF-8"));
	boolean found = false;
	while (!found) {
	    String line = reader.readLine();
	    if (line == null) break;
	    if (line.equals(filename)) found = true;
	}
	reader.close();
	return found;
    }

    Writer indexOutputWriter(int hash) throws IOException {
	return new BufferedWriter(new OutputStreamWriter(new GZIPOutputStream(new FileOutputStream(getCompressedName(hash, INDEX_EXTENSION))), "UTF-8"));
    }
}
